using Blazorise;
using FoodsharingSiegen.Contracts.Entity;
using FoodsharingSiegen.Server.Data.Service;
using FoodsharingSiegen.Server.Dialogs;
using Microsoft.AspNetCore.Components;

namespace FoodsharingSiegen.Server.Pages
{
    /// <summary>
    ///     The profile class (a. beging, 21.05.2022)
    /// </summary>
    public partial class Profile
    {
        #region Dependencies

        /// <summary>
        ///     Gets or sets the value of the user service (ab)
        /// </summary>
        [Inject]
        public UserService? UserService { get; set; }

        #endregion

        #region Private Properties

        /// <summary>
        ///     Gets or sets the value of the password modal (ab)
        /// </summary>
        private SetPasswordModal? PasswordModal { get; set; }

        /// <summary>
        ///     Gets or sets the value of the user (ab)
        /// </summary>
        private User User { get; set; } = new();

        /// <summary>
        ///     Gets or sets the value of the validations ref (ab)
        /// </summary>
        private Validations? ValidationsRef { get; set; }

        #endregion

        #region Override OnAfterRenderAsync

        /// <summary>
        ///     Ons the after render using the specified first render (a. beging, 21.05.2022)
        /// </summary>
        /// <param name="firstRender">The first render</param>
        protected override async Task OnAfterRenderAsync(bool firstRender)
        {
            if (firstRender) await ValidationsRef?.ValidateAll()!;
            await base.OnAfterRenderAsync(firstRender);
        }

        #endregion

        #region Override OnInitializedAsync

        /// <summary>
        ///     Ons the initialized (a. beging, 21.05.2022)
        /// </summary>
        protected override async Task OnInitializedAsync()
        {
            await base.OnInitializedAsync();
            User = CurrentUser.Clone();
        }

        #endregion

        #region Private Method ChangePassword

        /// <summary>
        ///     Changes the password (a. beging, 23.05.2022)
        /// </summary>
        private async Task ChangePassword()
        {
            await Notification?.Success("Die Funktion ist noch nicht fertig! :)")!;
        }

        #endregion

        #region Private Method OnPasswordSet

        /// <summary>
        ///     Ons the password set using the specified arg (a. beging, 23.05.2022)
        /// </summary>
        /// <param name="arg">The arg</param>
        private async Task OnPasswordSet(User arg)
        {
            var setPasswordR = await UserService?.SetPassword(arg)!;
            if (setPasswordR.Success)
                NavigationManager?.NavigateTo("/logout");
            else
                await Notification?.Success(setPasswordR.ErrorMessage)!;
        }

        #endregion

        #region Private Method RemoveAccount

        /// <summary>
        ///     Removes the account (a. beging, 23.05.2022)
        /// </summary>
        private async Task RemoveAccount()
        {
            await Notification?.Success("Die Funktion ist noch nicht fertig! :)")!;
        }

        #endregion

        #region Private Method SaveProfile

        /// <summary>
        ///     Saves the profile (a. beging, 21.05.2022)
        /// </summary>
        private async Task SaveProfile()
        {
            var updateR = await UserService?.Update(User)!;
            if (updateR.Success)
            {
                await Notification?.Success("Profil gespeichert!")!;
                await RefreshState();
            }
            else
            {
                await Notification?.Error(updateR.ErrorMessage)!;
            }
        }

        #endregion
    }
}